<%
'===================================================================================
' SAMPLE Store Locator Application
'
' LANGUAGE: VBScript
' DATABASE: Microsoft Access
'
' This script showcases the methods employed to implement a store locator system
' into your website or application.
'
'
' AUTHOR: DataSheer, LLC
' WEBSITE: www.zip-codes.com
' DATE: 1/16/2008
'===================================================================================


'--> This string sets the path to the sample access database
dbStr = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Server.MapPath("StoreLocator.mdb")

'--> Here, we use the database connection string to create a database connection object
set dbConn = Server.CreateObject("ADODB.Connection")
dbConn.Open(dbStr)

'--> Collect the fMiles value. If a numeric value is NOT passed, use a default value. This is the Max Distance.
if (request("fMiles") <> "" and isnumeric(request("fMiles"))) then fMiles = clng(request("fMiles")) else fMiles = 25

'--> Collect the fZip value. This is the users 'home' ZIP Code.
fZip = request("fZip")
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Sample Store Locator by www.zip-codes.com</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<style type="text/css">
.tblResults{
	border-top:1px solid #000000;
	border-left:1px solid #000000;

}
th{
font-size: 12px;
font:Verdana, Arial, Helvetica, sans-serif;
font-weight:bold;
background-color:#CCCCCC;
border-bottom:1px solid #000000;
border-right:1px solid #000000;
}
td{
font-size: 11px;
font-family:Verdana, Arial, Helvetica, sans-serif;
border-bottom:1px solid #000000;
border-right:1px solid #000000;
}
</style>
<body>
<h1>Store Locator</h1>

<!-- This form lets the user input their ZIP Code and a Max Distance they wish to find stores in. -->
<form name="Form" method="post">
<p style="font-size:11px; font-family:Verdana, Arial, Helvetica, sans-serif;">
  Search for Stores within: 
  <input name="fMiles" type="text" id="fMiles" value="<%=fMiles%>" size="5" maxlength="5"> 
  miles of zip code 
  <input name="fZip" type="text" id="fZip" value="<%=fZip%>" size="5" maxlength="5">
  . 
  <input type="submit" name="Submit" value="Search">
  <br />
  <span style="color:#999999;">This sample app can accept these ZIP Codes: 10005, 10006, 10007, 32503, 32504, 32505, 35045, 35046, 35048, 75965, 75966, 75968, 90210, 90211, 90212, 90213.</span>
  </p>
</form>

<%
'--> Process the form Submission
if request("submit") <> "" then

	'--> Lookup the entered ZIP Code to see if it is valid, as well as getting the latitude/lonitude values
	set chk = dbConn.execute("SELECT Latitude, Longitude FROM ZipCodes WHERE ZipCode = '" & replace(fZip, "'", "''") & "'")
		if chk.EOF then
			'--> ZIP Code does not exist, print error message
			%><p style="color:#FF0000; font-weight:bold;">Error: Invalid ZIP Code, or ZIP Code not found.</p><%
		else
			'--> Set Lat/Long values for the Point ZIP Code to variables
			baseLatitude = cdbl(chk("Latitude"))
			baseLongitude = cdbl(chk("Longitude"))
%>
<h2>Search Results </h2>
<table border="0" cellspacing="0" cellpadding="2" class="tblResults">
  <tr>
    <th>Distance</th>
    <th>Store</th>
    <th>Location</th>
    <th>Phone</th>
    <th>Fax</th>
    <th>Email</th>
  </tr>
<%
' To find all the stores from an access database, we calculate a Square Radius from the target ZIP Code.
' The RadiusAddonLat and RadiusAddonLon functions give us the values to add/subtract from the target ZIP
' Code Lat/Long values. Then we use the Distance Calculator function to calculate exact radius distance.


'--> Get the Lat/Lon Add/Subtract values
LatValue = RadiusAddonLat(baseLatitude, fMiles)
LonValue = RadiusAddonLon(baseLatitude, fMiles)

'--> Create Our SQL String to pull out stores from the database
strSQL = "SELECT * FROM Stores INNER JOIN ZIPCodes ON Stores.stZIP = ZIPCodes.ZipCode"
strSQL = strSQL & " WHERE City = CityAliasName"
strSQL = strSQL & " AND (Latitude <= (" & baseLatitude & " + " & LatValue & ") OR Latitude >= (" & baseLatitude & " - " & LatValue & "))"
strSQL = strSQL & " AND (Longitude <= (" & baseLongitude & " + " & LonValue & ") OR Longitude >= (" & baseLongitude & " - " & LonValue & "))"
strSQL = strSQL & " ORDER BY stName ASC"
'response.write strSQL : response.flush()

'--> Create Database Recordset and loop through the records
set getRecords = dbConn.execute(strSQL)
	while NOT getRecords.EOF
		'--> Set all store values to variables
		stID = getRecords("stID")
		stName = getRecords("stName")
		stAddress = getRecords("stAddress")
		stCity = getRecords("stCity")
		stState = getRecords("stState")
		stZip = getRecords("stZIP")
		stPhone = getRecords("stPhone")
		stFax = getRecords("stFax")
		stEmail = getRecords("stEmail")
		sLatitude = cdbl(getRecords("Latitude"))
		sLongitude = cdbl(getRecords("Longitude"))
		
		'--> Use this function to calculate the actual distance for this store
		sDistance = cdbl(FormatNumber(DistanceCalc(baseLatitude, baseLongitude, sLatitude, sLongitude, "M"), 2, -2, -2, -2))
		
		'--> Only show this record if it's distance is less than what the user entered
		if sDistance <= fMiles then
%>
  <tr>
    <td><%=sDistance%> Miles</td>
    <td><%=stName%></td>
    <td><%=stAddress%><br><%=stCity%>, <%=stState%> <%=stZip%></td>
    <td><%=stPhone%></td>
    <td><%=stFax%></td>
    <td><a href="mailto:<%=stEmail%>"><%=stEmail%></a></td>
  </tr>
<%
		end if
	getRecords.movenext()
	wend
'--> Close recordset connection
set getRecords = nothing
%>
</table>
<%
		end if
	set chk = nothing
end if
%>
<p>&nbsp;</p>
</body>
</html>
<%
'--> Close the database connection.
set dbConn = nothing


'================================================================
'=== FUNCTIONS ==================================================
'================================================================


' Distance Calculator
'===================================================================
' This function calculates the distance between two latitude/logitude
' coordinates. Disance can be returned as Nautical Miles, Kilometers,
' or Miles (default).
'
'
' This function was designed for VBScript
'
' Accepts:
'	Lat1 = Latitude of point one (decimal, required)
'	Lon1 = Longitude of point one (decimal, required)
'	Lat2 = Latitude of point two (decimal, required)
'	Lon2 = Longitude of point two (decimal, required)
'	UnitFlag = Non required character K, N, or M
'		where:
'			K = Kilometers
'			N = Nautical Miles
'			M = Miles [default]
'
' Provided by: http://www.zip-codes.com
'===================================================================
Public Function DistanceCalc(Lat1, Lon1, Lat2, Lon2, UnitFlag)
    Dim LatRad1, LonRad1, LatRad2, LonRad2, LonRadDif, RadDist, X, PI, DistMI
    PI = 3.141592654
    If IsNull(Lat1) Then
        Exit Function
    End If
    If Lat1 = 0 Or Lon1 = 0 Or Lat2 = 0 Or Lon2 = 0 Then
        DistanceCalc = Null
        Exit Function
    ElseIf Lat1 = Lat2 And Lon1 = Lon2 Then
        DistanceCalc = 0
        Exit Function
    End If
    LatRad1 = Lat1 * PI / 180
    LonRad1 = Lon1 * PI / 180
    LatRad2 = Lat2 * PI / 180
    LonRad2 = Lon2 * PI / 180
    LonRadDif = Abs(LonRad1 - LonRad2)
    X = Sin(LatRad1) * Sin(LatRad2) + Cos(LatRad1) * Cos(LatRad2) * Cos(LonRadDif)
    RadDist = Atn(-X / Sqr(-X * X + 1)) + 2 * Atn(1)
    DistMI = RadDist * 3958.754
    If UCase("" & UnitFlag) = "K" Then
		DistanceCalc = DistMI * 1.609344
	ElseIf UCase("" & UnitFlag) = "N" Then
		DistanceCalc = DistMI * 0.8684
	Else
		DistanceCalc = DistMI
	End If
End Function



' Latitude Addon
'===================================================================
' This function calculates a square radius and returns a number to
' add/subtract from the latitude to filter and narrow results.
'===================================================================
function RadiusAddonLat(varLatitude, varMiles)
	RadiusAddonLat = varMiles / ((6076 / 5280) * 60) + varMiles / 1000
end function

' Longitude Addon
'===================================================================
' This function calculates a square radius and returns a number to
' add/subtract from the lonitude to filter and narrow results.
'===================================================================
function RadiusAddonLon(varLatitude, varMiles)
	RadiusAddonLon = varMiles / (((cos(cdbl(varLatitude * 3.141592653589 / 180)) * 6076) / 5280) * 60) + varMiles / 1000
end function
%>
